// C++11
#include <iostream>
#include <string>
#include <vector>
 
using namespace std;

class CrosswordPuzzler {
public:
  vector<string> createPuzzle (int width, int height, vector<string> dict) {
    vector<string> ret;
    ret.push_back(dict[0]);
    while (ret[0].length() < width) ret[0] += "-";
    for (int i = 1; i < height; i++) ret.push_back(string(width, '-'));
    return ret;
  }
};

int main() {
   CrosswordPuzzler sol;
   int width;
   int height;
   int size;
   vector<string> dict;
   string s;
   getline(cin, s);
   width = atoi(s.c_str());
   getline(cin, s);
   height = atoi(s.c_str());
   getline(cin, s);
   size = atoi(s.c_str());
   for (int i = 0; i < size; i++) {
     getline(cin, s);
     dict.push_back(s);
   }
   vector<string> ret = sol.createPuzzle(width, height, dict);
   cout << ret.size() << endl;
   for (int i = 0; i < ret.size(); i++)
     cout << ret[i] << endl;
   cout.flush();
}
